/**
 * Copyright (C) 2011 by Ben Noordhuis <info@bnoordhuis.nl>
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
 * THE SOFTWARE.
 */
#ifndef PUNYCODE_H_
#define PUNYCODE_H_

#ifdef WIN32
#if (_MSC_VER > 1900)
#include <stdint.h> 
#else
#include "mystdint.h"
#endif
#else
// for freebsd, need to test.
#include <stdint.h>
#include <ctype.h>
#include <stdio.h>

#endif 

#include <stddef.h>

/**
 * Convert Unicode to Punycode. Returns the number of Unicode characters that were converted.
 */

size_t punycode_encode(const uint32_t *const src, const size_t srclen, char *const dst, size_t *const dstlen);


/**
 * Convert Punycode to Unicode. Returns the number of bytes that were converted.
 */
size_t punycode_decode(const char *const src, const size_t srclen, uint32_t *const dst, size_t *const dstlen) ;

#endif /* punycode.h */
